import React, { useState, useEffect } from 'react';
export { default as React } from 'react';
import { createSlice, configureStore } from '@reduxjs/toolkit';
import { useSelector, useDispatch, Provider } from 'react-redux';
import Navbar from 'react-bootstrap/Navbar';
import Container from 'react-bootstrap/Container';
import Nav from 'react-bootstrap/Nav';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var configSlice = createSlice({
  name: 'config',
  initialState: {
    cmpPositions: {}
  },
  reducers: {
    setComptPositions: function setComptPositions(state, action) {
      state.cmpPositions = _extends({}, state.cmpPositions, action.payload);
    }
  }
});
var setComptPositions = configSlice.actions.setComptPositions;
var configSlice$1 = configSlice.reducer;

var store = configureStore({
  reducer: {
    config: configSlice$1
  }
});

var InternalNavBar = function InternalNavBar(props) {
  var _useState = useState(0),
      scrollY = _useState[0],
      setScrollY = _useState[1];

  var _useState2 = useState(true),
      scrollSpy = _useState2[0],
      setScrollSpy = _useState2[1];

  var globalState = useSelector(function (state) {
    return state.config.cmpPositions;
  });
  document.addEventListener('scroll', function (e) {
    setScrollY(window.scrollY);
  });

  var renderChildren = function renderChildren() {
    return React.Children.map(props.children, function (child) {
      return React.cloneElement(child, _extends({
        scrollSpy: scrollSpy,
        setScrollSpy: setScrollSpy
      }, child.props));
    });
  };

  var navLinks = props.items.map(function (i) {
    try {
      return /*#__PURE__*/React.createElement(Nav.Link, {
        key: i.id,
        href: '#' + i.id,
        active: scrollY >= globalState[i.id][0] && scrollY < globalState[i.id][1]
      }, i.item);
    } catch (e) {
      console.log('items can not be calculated yet...waiting on positions');
      return [];
    }
  });
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Navbar, {
    bg: props.bg,
    variant: props.variant,
    fixed: "top"
  }, /*#__PURE__*/React.createElement(Container, null, /*#__PURE__*/React.createElement(Navbar.Brand, {
    href: "#home"
  }, props.img), /*#__PURE__*/React.createElement(Nav, {
    className: ""
  }, navLinks))), renderChildren());
};

var ItemScrollSpy = function ItemScrollSpy(props) {
  var dispatch = useDispatch();
  useEffect(function () {
    var paddingTop = props.paddingTop ? props.paddingTop : 0;
    var paddingBottom = props.paddingBottom ? props.paddingBottom : 0;
    var hight = document.querySelector('#' + props.scrollSpyId).offsetHeight;
    var top = document.querySelector('#' + props.scrollSpyId).offsetTop;

    if (props.scrollSpy) {
      var _setComptPositions;

      props.setScrollSpy(false);
      dispatch(setComptPositions((_setComptPositions = {}, _setComptPositions[props.scrollSpyId] = [top + paddingTop, top + hight + paddingBottom], _setComptPositions)));
    }
  });
  return /*#__PURE__*/React.createElement("div", {
    id: props.scrollSpyId
  }, props.children);
};

var NavBarScrollSpy = function NavBarScrollSpy(props) {
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Provider, {
    store: store
  }, /*#__PURE__*/React.createElement(InternalNavBar, props, props.children)));
};

export { ItemScrollSpy, NavBarScrollSpy };
//# sourceMappingURL=index.modern.js.map
